SystemOrganization addCategory: #CMakeVMMaker!
SystemOrganization addCategory: #'CMakeVMMaker-Unix'!
SystemOrganization addCategory: #'CMakeVMMaker-Unix-Cog'!
SystemOrganization addCategory: #'CMakeVMMaker-Windows'!
SystemOrganization addCategory: #'CMakeVMMaker-MacOS'!
SystemOrganization addCategory: #'CMakeVMMaker-IOS'!
SystemOrganization addCategory: #'CMakeVMMaker-FreeBSD-Cog'!

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/21/2010 14:26'!
addExtraCMakeRules: maker
	"Add extra rules/commands to cmake configuration for building this plugin.
	By default , do nothing"! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/22/2010 01:10'!
generateFor: aCMakeVMGenerator internal: aBoolean 

	^ aCMakeVMGenerator 
		generatePlugin: self 
		internal: aBoolean
		extraRules: nil! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/20/2010 04:18'!
supportedPlatforms: enum
" use:
	^ enum unix
or:
	^ enum unix, enum osX
	
or 

	^ enum unix i386, enum osX
"
	^ enum all! !

Object subclass: #CMakeGenScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeGenScripts commentStamp: 'Igor.Stasenko 12/30/2010 09:53' prior: 0!
This class is a collection of scripts for generating both
C source files (using VMMaker) and Cmake files.!

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:54'!
fileout: aString to: aFileName

	" put that file to ../codegen-scripts directory "
	
 	(FileStream forceNewFileNamed: aFileName) 
		nextPutAll: aString;
		close.
	! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:53'!
fileoutLoaderScript
"self fileoutLoaderScript"


	" put that file to ../codegen-scripts directory "
	
	self fileout: self loaderScript to: self loaderScriptName.! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'EstebanLorenzano 2/6/2011 09:15'!
generateCocoaVM
	| platformDirectoryName |

"B3DAcceleratorPlugin" "Not using it right now"

	platformDirectoryName := (FileDirectory default 
		containingDirectory 
			directoryNamed: 'platforms') 
				fullName.
	VMMaker default 
		platformRootDirectoryName:  platformDirectoryName; 
		sourceDirectoryName: platformDirectoryName, '/iOS/vm/src';
		internal: #(
			ADPCMCodecPlugin 
			B3DEnginePlugin 
			BalloonEnginePlugin
			BitBltSimulation 
			BMPReadWriterPlugin 
			ClipboardExtendedPlugin 
			DeflatePlugin 
			DSAPlugin 
			FFIPlugin 
			FFTPlugin 
			FilePlugin 
			FloatArrayPlugin 
			GeniePlugin 
			HostWindowPlugin 
			JPEGReaderPlugin 
			JPEGReadWriter2Plugin 
			KlattSynthesizerPlugin 
			LargeIntegersPlugin 
			Matrix2x3Plugin 
			MacMenubarPlugin 
			MiscPrimitivePlugin
			NewsqueakIA32ABIPlugin 
			ObjectiveCPlugin
			RePlugin 
			SecurityPlugin 
			SocketPlugin 
			SoundCodecPlugin 
			SoundGenerationPlugin 
			SoundPlugin 
			StarSqueakPlugin 
			SurfacePlugin 
			UUIDPlugin 
			DropPlugin)	
		external: #(
			UnixOSProcessPlugin);
		generateMainVM;
		generateExternalPlugins.

	"Gnuifier"
	(Gnuifier on:((FileDirectory on: platformDirectoryName, '/iOS/vm/src/vm') pathName)) gnuify.	
! !

!CMakeGenScripts class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/30/2010 15:53'!
generateCogMacOS
	" generate sources for Stack Interpreter of Mac OS"
	| top |
	top := FileDirectory default containingDirectory.				
	
	VMMaker
		generate: CoInterpreter
		to: (top / 'src') fullName
		platformDir: ( top / 'platforms') fullName
		excluding:#(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
					FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin).
						
	CogMacOSConfig generate.

	! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'Igor.Stasenko 1/28/2011 10:33'!
generateCogSources
	" self generateCogSources "

	" generate sources for CoInterpreter"

	| top |
	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
	top := FileDirectory default containingDirectory.				
	
	VMMaker
		generate: CoInterpreter
		and: StackToRegisterMappingCogit
		to: (top / 'src') fullName
		platformDir: ( top / 'platforms') fullName
		excluding:#(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
					FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin NewsqueakIA32ABIPlugin
					 NewsqueakIA32ABIPluginAttic).
! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'Igor.Stasenko 1/28/2011 15:59'!
generateCogSources: config
	" self generateCogSources "

	" generate sources for CoInterpreter"

	| top src |
	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
	top := config topDir.				
	src := config srcDir assureExistence fullName.
	
	VMMaker
		generate: CoInterpreter
		and: StackToRegisterMappingCogit
		to: src
		platformDir: ( top / 'platforms') fullName
		excluding:#(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
					FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin NewsqueakIA32ABIPlugin
					 NewsqueakIA32ABIPluginAttic).
! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'Igor.Stasenko 1/1/2011 20:59'!
generateCogSourcesEmm40
	" self generateCogSourcesEmm40 "


	" generate sources for CoInterpreter"

	| top |
	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
	top := FileDirectory default containingDirectory.				
	
	VMMaker
		generate: CoInterpreter
		and: StackToRegisterMappingCogit
		to: (top / 'src') fullName
		platformDir: ( top / 'platforms') fullName
		excluding:#(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
					FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin 					ReentrantPPCBEFFIPlugin NewsqueakIA32ABIPlugin
					 NewsqueakIA32ABIPluginAttic).
! !

!CMakeGenScripts class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/30/2010 22:54'!
generateStackMacOS
	" generate sources for Stack Interpreter of Mac OS"
	self generateStackSources.
		
	StackInterpreterMacOSConfig generate.

	! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'Igor.Stasenko 12/30/2010 22:54'!
generateStackSources
	" generate sources for Stack Interpreter of Mac OS"
	| top |
	top := FileDirectory default containingDirectory.
	
	VMMaker
		generate: StackInterpreter
		to: (top / 'src') fullName
		platformDir: ( top / 'platforms') fullName
		excluding: #(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
			FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin).
			
	

	! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'IgorStasenko 3/26/2011 14:37'!
loaderScript

"
Gofer new
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfCog';
	load.
	
((Smalltalk at: #ConfigurationOfCog) project
	version: '1.5') load.

	
((MCHttpRepository 	location: 'http://www.squeaksource.com/VMMaker' user: '' password: '')
versionFromFileNamed: 'CMakeVMMaker-IgorStasenko.52.mcz') load.

	
(Smalltalk saveAs: 'generator.image') ifFalse: [
				 Smalltalk snapshot: false andQuit: true]
"

" i put it into comment to avoid double quoting "

^  thisContext  method methodNode comment first

! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:53'!
loaderScriptName
	^ 'LoadVMMaker.st'! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/27/2011 12:19'!
mcPackage: name
	
	|pkg|
	pkg := MCWorkingCopy allManagers detect: [:ea | ea packageName = name ].
	
	^ pkg ancestry ancestorString , '.mcz'
	! !

!CMakeGenScripts methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/30/2010 09:52'!
seeClassSide! !

Object subclass: #CMakeGenerator
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeGenerator commentStamp: 'Igor.Stasenko 12/24/2010 02:53' prior: 0!
a base class for generating cmake files.
Mainly provides a helper methods of cmake commands api.!

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:15'!
addDefinitions: aString
	^ self cmd: 'add_definitions' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 16:58'!
addExternalLibraries: libs

	libs do: [:each | self addExternalLibrary: each ]! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 16:57'!
addExternalLibrary: aLibrary 

	self cmd: 'target_link_libraries' 
		params: self moduleName , ' ' , aLibrary.
		
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/19/2011 10:22'!
addFrameworks: aCollection 
	"for mac only "
	aCollection
		do: [:each | 
			self cmd: 'find_library' params:  each , '_FMWK ', each.
			self addExternalLibrary: '${', each , '_FMWK}' ]! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 1/10/2011 19:45'!
addProperty: propertyString value: valueString 
	self puts: 'set_target_properties(' , self moduleName , ' PROPERTIES ' , propertyString , ' "' , valueString, '")'
! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 13:14'!
addSource: aFileName

	^ self addSources: { aFileName }! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 12:09'!
addSources: aFileNames

	^ self addSources: aFileNames prefixed: ''! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 13:16'!
addSources: aFileNames prefixed: aPrefix

	| names |
	names := aFileNames inject: '' into: [:res :each | res , ' "' , aPrefix, each, '"' ].
	
	self puts: 'list(APPEND sources ', names , ')'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:16'!
addSubdirectory: aDir

	^ self cmd: 'add_subdirectory' qparams: aDir. 
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 1/10/2011 19:46'!
addXCodeProperty: propertyString value: valueString 
	self 
		addProperty: 'XCODE_ATTRIBUTE_' , propertyString 
		value: valueString
! !

!CMakeGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 1/14/2011 18:56'!
captureOutputDuring: aBlock
	| old result |
	
	old := output.
	output :=  String new writeStream.
	
	aBlock value.
	
	result := output.
	output := old.
	
	^ result contents! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:18'!
cmd: cmdName params: aString

	output nextPutAll: cmdName;
		nextPut: $(;
		nextPutAll: aString;
		nextPut: $);
		cr
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:18'!
cmd: cmdName qparams: aString
	"quoted params"
	output nextPutAll: cmdName;
		nextPutAll: '("';
		nextPutAll: aString;
		nextPutAll: '")';
		cr
! !

!CMakeGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 12/21/2010 19:02'!
generate
	self subclassResponsibility.! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 14:53'!
include: aFileName
	^ self cmd: 'include' params: aFileName! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:19'!
includeDirectories: aString
	^ self cmd: 'include_directories' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:24'!
message: aString
	
	self cmd: 'message' qparams: aString.! !

!CMakeGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName
	self subclassResponsibility! !

!CMakeGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/20/2010 01:55'!
outputFileName
	^ 'CMakeLists.txt'! !

!CMakeGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:43'!
printHeader
	
	self puts: '# This is automatically generated file using ', self configurationName, ' on ',
		Date current asString, ' ' , Time current asString;
		puts: 'cmake_minimum_required(VERSION 2.6.2)';
		puts: 'include(CMakeDetermineSystem)'.! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:19'!
project: aProjectName
	self cmd: 'project' qparams: aProjectName
! !

!CMakeGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/20/2010 01:36'!
puts: aString
	output nextPutAll: aString; cr! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:20'!
set: variableName to: aValueString

	self cmd: 'set' params: variableName , ' ' , aValueString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/20/2010 03:09'!
set: variableName toString: aValueString

	^ self set: variableName to: '"', (aValueString copyReplaceAll: '"' with: '\"'), '"'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'NicolasPasserini 3/30/2011 14:48'!
setTargetProperties: properties 
	self cmd: 'set_target_properties' params: self moduleName, ' PROPERTIES ', properties ! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 3/23/2011 14:11'!
setTargetProperty: propertyString to: aString
	self 
		cmd: 'set_target_properties'
		params: (String streamContents: [ :stream |
			stream 
				nextPutAll: self moduleName;
				nextPutAll: ' PROPERTIES ';
				nextPutAll: propertyString;
				space;  
				nextPutAll: aString ])! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 3/23/2011 14:12'!
setTargetProperty: propertyString toAll: aCollection
	^self 
		setTargetProperty: propertyString 
		to: (String streamContents: [ :stream | 
			aCollection 
				do: [ :each | stream nextPutAll: each ]
				separatedBy: [ stream nextPut: $, ] ])! !

CMakeGenerator subclass: #CMakePluginGenerator
	instanceVariableNames: 'plugin vmGen internal extraRules doNotGenerate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakePluginGenerator commentStamp: 'Igor.Stasenko 12/25/2010 04:21' prior: 0!
I am using for generating CMakeLists.txt (cmake config files) for specific plugin.
The direct use of my instances is not recommended.
Use CMakeVMGenerator and appropriate configuration to generate both VM and plugins cmake config files.!

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 14:38'!
addCrossSources: sources

	^ self addSources: sources prefixed: '${pluginCross}/'
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 12:51'!
addPlatformSources: sources

	^ self addSources: sources prefixed: '${pluginPlatform}/'
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 09:52'!
config
	^ vmGen config! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:44'!
configurationName
	^ vmGen configurationName! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/27/2010 14:00'!
doNotGenerate

	"Forcely exclude plugin form build. Use this method only for debugging purposes.
	
	Front-end users should simply specify different list of plugins for building VM,
	effectively excluding any unwanted stuff "
	
	^doNotGenerate! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/27/2010 13:59'!
doNotGenerate: aValue

	"Forcely exclude plugin form build. Use this method only for debugging purposes.
	
	Front-end users should simply specify different list of plugins for building VM,
	effectively excluding any unwanted stuff "
	
	doNotGenerate := aValue! !

!CMakePluginGenerator methodsFor: 'code generation' stamp: 'EstebanLorenzano 3/23/2011 15:11'!
generate

	| name |
	output := String new writeStream.

	name := plugin moduleName.
	self 
		printHeader;
		project: name;
		"include directories generated for build"
		include: '../directories.cmake'.
		
	self message: (internal ifTrue: [ 'Adding internal plugin: '] ifFalse: ['Adding external plugin: '])  , name.

	self 
		set: #pluginName toString: name;
		set: #pluginSrc toString: '${srcPluginsDir}/', name;
		set: #pluginCross toString: '${crossDir}/plugins/', name;
		set: #pluginPlatform to: '${targetPlatform}/plugins/', name.
		
	
	internal ifTrue: [
		self puts: 'add_definitions(-DSQUEAK_BUILTIN_PLUGIN)'].
	
	self addSources: { name , '.c' } prefixed: '${pluginSrc}/'.

	" default include directories for plugin "
	self includeDirectories: '${pluginSrc} ${pluginCross} ${targetPlatform}/plugins/${pluginName}'.
	
	self addDefinitions: vmGen config compilerFlags.

	" perform config's configureXYZ: message to apply per-plugin custom rules, if any "
	
	vmGen config configurePlugin: plugin with: self.
	
	extraRules ifNotNil: [ extraRules value: self ].
	
	" generate a static lib for internal plugin, or shared for external"
	internal ifTrue: [
		self cmd: 'add_library' params:  name , ' STATIC ${sources}'.
	] ifFalse: [
		self cmd: 'add_library' params: name , ' SHARED ${sources}'.
		
	"	self cmd: 'set_property' params: 'TARGET ' , name , ' PROPERTY LINK_FLAGS -bundle'"
	].

	vmGen config extraPluginSettings: self.
	
	" see senders of #linkFlags "
	self 
		cmd: 'set_property' 
		params: 'TARGET ', name, ' PROPERTY LINK_FLAGS "${linkFlags}"'.
	
	self saveFile.! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/27/2010 14:02'!
generate: aPlugin for: aCMakeVMGenerator internal: aBoolean extraRules: aBlock

	doNotGenerate := false.
	internal := aBoolean.
	plugin := aPlugin.
	vmGen := aCMakeVMGenerator.
	extraRules := aBlock.
		
	^ self generate! !

!CMakePluginGenerator methodsFor: 'testing' stamp: 'Igor.Stasenko 12/29/2010 15:42'!
isExternal
	^ internal not! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/29/2010 15:42'!
isInternal
	^ internal! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName 
	^plugin moduleName! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 03:19'!
saveFile
	
	((vmGen buildDir / plugin moduleName) assureExistence forceNewFileNamed: self outputFileName) 
		nextPutAll: (self config fixLineEndsOf: output contents); close.
! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 01:07'!
vmGenerator
	"Make it accessible from plugin generator side"
	^ vmGen! !

CMakeGenerator subclass: #CMakeVMGenerator
	instanceVariableNames: 'internalPlugins externalPlugins config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeVMGenerator commentStamp: 'Igor.Stasenko 12/25/2010 04:25' prior: 0!
I am generating a cmake configuration file (CMakeLists.txt)
for building a Squeak Virtual Machine.

Usage: 

CMakeVMGenerator new generate: CogMacOSConfig

or

CMakeVMGenerator new generate: (CogMacOSConfig new setOption: ... ; yourself)

you can provide any valid configuration instead of CogMacOSConfig for build. 

Generator creating a '../build' directory (relative to current one)
and placing config files there.
Also, it expects that appropriate VM (re)sources can be found simplarily:
  ../platforms
  ../src
 but these settings are just default ones and could be changed in config
 (see senders of #topDir #buildDir and #srcDir )

Generator and cmake configs are designed so, that any file-system operations are performed in
<build> directory.
So, if you want to build multiple VMs , using same generated sources, but different configs, you can simply
use different build directories.

!

!CMakeVMGenerator class methodsFor: 'code generation' stamp: 'EstebanLorenzano 1/10/2011 19:52'!
generate: aConfigOrClass  
	^self new 
		generate: aConfigOrClass;
		yourself  ! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 15:33'!
append: aString toAll: list
	"flatten the list, adding prefix for each element"
	^ list inject: '' into: [:result :each | result, ' ', aString, each ].! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/18/2011 14:56'!
buildDir
	^ config buildDir! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:54'!
config
	^ config! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:44'!
configurationName
	^ config class name! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 02:04'!
executableName
	^ 'Squeak'! !

!CMakeVMGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 1/18/2011 15:51'!
generate
		
	output := String new writeStream.
		
	self 
		printHeader;
		project: config executableName.

	config setupDirectories: self.
	self include: 'directories.cmake'.
		
	self message: '${CMAKE_MODULE_PATH}'.
	self set: 'CMAKE_CONFIGURATION_TYPES' to: 'Debug Release'.
	self message: '${CMAKE_CONFIGURATION_TYPES}'.
	
	config preferredIncludes 
		do: [ :each | self includeDirectories: each ].
	self includeDirectories: self includeDirs.	
	config standardIncludes 
		do: [:each | self includeDirectories: each ].

	self addDefinitions: config compilerFlags.

	config extraVMSettings: self.
	
	self puts: 'add_executable(' , config executableName, ' ', config executableType, ' ' , self sources , ')'.
		
	self processInternalPlugins.	
	config setExtraTargetProperties: self.
		
	self processExternalPlugins.
	
	self saveFile.
	! !

!CMakeVMGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 12/24/2010 02:06'!
generate: aConfigOrClass
	
	config := aConfigOrClass isBehavior ifTrue: [ aConfigOrClass new ] ifFalse: [aConfigOrClass].
	^ self generate! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 11:53'!
generateExportsH: libs
	| content |
	content := String streamContents: [:str |
	
		str nextPutAll: '/* This is automatically generated file using CVMMaker on ',
			Date current asString, ' ' , Time current asString , ' */'; cr.
		
		str nextPutAll: 
'extern sqExport vm_exports[];
extern sqExport os_exports[];
'.
		libs do: [:each | 
			str nextPutAll: 'extern sqExport ', each ,'_exports [];'; cr ].
		
		str cr; nextPutAll: 'sqExport *pluginExports[] = {
	vm_exports,
	os_exports,
'.

		libs do: [:each | 
			str nextPutAll:  each ,'_exports,'; cr ].
	
		str nextPutAll: 'NULL
};'

	].

	(self buildDir forceNewFileNamed: 'sqNamedPrims.h') nextPutAll: (config fixLineEndsOf: content); close.
	! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 01:13'!
generatePlugin: aPlugin internal: aBoolean extraRules: aBlock
	" this method called back from plugin"
	^ CMakePluginGenerator new
		generate: aPlugin for: self internal: aBoolean extraRules: aBlock! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 11:57'!
includeDirs

	^ '${crossDir}/vm ${srcVMDir} ${targetPlatform}/vm ${buildDir}'.! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 00:14'!
internalPlugins: intList externalPlugins: extList

	internalPlugins := intList.
	externalPlugins := extList.! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName 
	^config executableName! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:47'!
platformName
	^ config platformName
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/29/2010 15:31'!
processExternalPlugins

	config externalPlugins do: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: false.
		gen doNotGenerate ifFalse: [
			self addSubdirectory: plugin moduleName.
			]
	].
	
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/29/2010 15:20'!
processInternalPlugins

	| libs |
	libs := OrderedCollection new.

	config internalPlugins collect: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: true.
		gen doNotGenerate ifFalse: [
			libs add: plugin moduleName.
			self addSubdirectory: plugin moduleName.
			 ].
		].
	
	self cmd: 'target_link_libraries' params:  config executableName , ' ' ,
		(libs inject: '' into: [:res :ea | res, ' ' , ea ]) .

	self generateExportsH: libs.
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/15/2011 14:54'!
saveFile
	
	config write: output contents toFile: (self outputFileName).
	! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/3/2011 08:09'!
setupMacros: gen
	self config cMakeMacros
		ifNotNil: [ :macros | gen puts: macros ]! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/18/2011 10:44'!
sources

	self set: #coreSources to: 
		(self append: '${srcVMDir}/' toAll: config coreSources).
		
	self set: #platformVMSources to: 
		(self append: '${targetPlatform}/vm/' toAll: config platformSources).
	
	
	self set: #crossVMSources to: 
		(self append: '${crossDir}/vm/' toAll: config crossSources).
		
	self set: #extraSources to: config extraSources.
	
	^ '${coreSources} ${crossVMSources} ${platformVMSources} ${extraSources}'! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 20:09'!
targetPropertyAt: aPropName put: aValue
	"set target's properties"
	
	self cmd: 'set_property' params: 'TARGET ', config executableName , 
	' PROPERTY ', aPropName , ' ' , aValue.
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 20:13'!
targetPropertyAt: aPropName qput: aValue
	"set target's properties, put value in quotes"
	
	^ self targetPropertyAt: aPropName put: (aValue copyReplaceAll: '"' with: '\"').! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 03:22'!
topDir
	| dir |
	dir := self config topDir ifNil: [ FileDirectory default containingDirectory ].
	dir isString ifTrue: [^ FileDirectory on: ( FileDirectory fullPathForURI: dir) ].
	^ dir! !

Object subclass: #CPlatformConfig
	instanceVariableNames: 'topDir buildDir srcDir platformsDir internalPlugins externalPlugins pluginsDir externalLibs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CPlatformConfig commentStamp: 'IgorStasenko 2/10/2011 17:56' prior: 0!
Base class, defining some common properties and behavior for all kinds of VM build configurations.

To generate a sources/build configuration use one of my subclasses with:
<config> generate.   - to generate a build configuration
<config> generateWithSources - to generate VMMaker sources and then build configuration.


Since some plugins require extra settings (like additional source files etc), there is two ways to add that:

- add custom rules on plugin class side:

PluginClass>>generateFor: aCMakeVMGenerator internal: aBoolean 

	^ aCMakeVMGenerator 
		generatePlugin: self 
		internal: aBoolean
		extraRules: [:maker |   ... your rules come here ... ]
		
- define rules by adding #configure<PluginClass>: method in config class (see my 'plugin extra rules' category)

The last one is more compact and also avoids inter-package dependency, so you can load and use
CMakeVMMaker even if some 3rd-party plugins are not loaded into image.


!

CPlatformConfig subclass: #CMsWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CMsWindowsConfig commentStamp: 'IgorStasenko 3/16/2011 19:06' prior: 0!
This is a root configuration for building VMs on MS-Windows platform.


What you need to get started:

Download and install Msys, with C/C++ compiler support:
	http://www.mingw.org/wiki/msys
	
Download and install Git:
	http://code.google.com/p/msysgit/
	

///
Optional: add git to the PATH variable:

Add path to git for msys:
Control panel -> System -> System Properies / Advanced  [ Environment Variables ]

There should be already:
C:\Program Files\Git\cmd

add:

C:\Program Files\Git\bin

/// For automated builds, add SQUEAKVM environment variable and set it to the full path to squeak executable.

(Control panel -> System -> System Properies / Advanced  [ Environment Variables ])

in windows shell you can use it then to run squeak: %SQUEAKVM%  , and in mingw bash shell, use $SQUEAKVM

/// Install CMake:
http://www.cmake.org/cmake/resources/software.html

(during installation, in install options , make sure that you choose to add CMake to PATH)


Note, to run cmake under msys shell, you have to explicitly specify the msys makefiles generator, because default one is MS:

cmake . -G"MSYS Makefiles"
!

!CMsWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/16/2011 18:20'!
commonCompilerFlags
	^ '-march=pentium4 -mwindows -D_MT -msse2 -ggdb2 -mthreads -mno-cygwin -mwin32 -mno-rtd -mms-bitfields -mno-accumulate-outgoing-args ', self winVer ,

	' -DWIN32 -DWIN32_FILE_SUPPORT -DNO_ISNAN -DNO_SERVICE -DNO_STD_FILE_SUPPORT ',
	'-DLSB_FIRST -DVM_NAME="', self executableName,'" -DX86 '! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:07'!
configureAsynchFilePlugin:  maker 
	"extra rules for AsynchFilePlugin "

	super configureAsynchFilePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32AsyncFilePrims.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:20'!
configureB3DAcceleratorPlugin:  maker 
	"extra rules for B3DAcceleratorPlugin "

	super configureB3DAcceleratorPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32DualB3DX.c' 'sqWin32D3D.c' 'sqWin32OpenGL.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:23'!
configureCroquetPlugin:  maker 
	"extra rules for CroquetPlugin "

	super configureCroquetPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32CroquetPlugin.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:06'!
configureDropPlugin:  maker 
	"extra rules for DropPlugin "

	super configureDropPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Drop')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 01:53'!
configureFilePlugin: maker 
	
	super configureFilePlugin: maker.
	
	maker addPlatformSources:
		#( 'sqWin32FilePrims.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:12'!
configureHostWindowPlugin:    maker 
	"extra rules for HostWindowPlugin "

	super configureHostWindowPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32HostWindowPlugin.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:03'!
configureJoystickTabletPlugin:  maker 
	
	super configureJoystickTabletPlugin:  maker.
	
	maker addPlatformSources:
		#( 'sqWin32Joystick.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:10'!
configureLocalePlugin:   maker 
	"extra rules for LocalePlugin "

	super configureLocalePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Locale.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:09'!
configureMIDIPlugin:  maker 
	"extra rules for MIDIPlugin "

	super configureMIDIPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32MIDI.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:24'!
configureMpeg3Plugin:  maker 
	"extra rules for Mpeg3Plugin "

	super configureMpeg3Plugin:  maker.
	
	maker addDefinitions: '-DNOPTHREADS'.

	maker addPlatformSources: #( 'sqOpenFile.c')! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:05'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqWin32Security')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:13'!
configureSerialPlugin:     maker 
	"extra rules for SerialPlugin "

	super configureSerialPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32SerialPort.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:08'!
configureSocketPlugin:  maker 
	"extra rules for SocketPlugin "

	super configureSocketPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32NewNet.c')


! !

!CMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 01:49'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
	
	maker addPlatformSources:
		#( 'sqWin32UUID.c')


! !

!CMsWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:26'!
executableType
	^ 'WIN32'! !

!CMsWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:29'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String crlf! !

!CMsWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:55'!
msysPathFor: aPath
	| path |
	
	path := aPath.
	
	path := path copyReplaceAll: '\' with: '/'.
	
	^ path " copyReplaceAll: '\' with: '\\'"! !

!CMsWindowsConfig methodsFor: 'directories' stamp: 'IgorStasenko 3/17/2011 02:32'!
outputDir

	"the directory where built binaries will be stored"
	
	^ self msysPathFor: (self buildDir fullName , '/results')! !

!CMsWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 16:51'!
platformName
	^ 'win32'! !

!CMsWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:55'!
setupDirectories: gen
	"we have to override that, because we need to convert windoze paths to msys ones"
	
	| dirsInclude |
	

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self msysPathFor: self topDir fullName); 
			set: #buildDir toString: (buildDir ifNil: ['${topDir}/build'] ifNotNil:[ self msysPathFor: buildDir ]);
			set: #platformsDir toString: (self msysPathFor: self platformsDir fullName);
			set: #srcDir toString: (self msysPathFor: self srcDir fullName);
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm'.
	].

	self write: dirsInclude toFile: 'directories.cmake'! !

!CMsWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:15'!
winVer
	"Set minimum version to WindowsXP (see /cygwin/usr/include//w32api/w32api.h)"
	
	^ '-D_WIN32_WINNT=0x0501 -DWINVER=0x0501'! !

CMsWindowsConfig subclass: #CogMsWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogMsWindowsConfig commentStamp: 'IgorStasenko 3/17/2011 02:48' prior: 0!
Configuration for building Cog JIT on Win32 platform.

Built artifacts are placed in ${build}/results dir.
Note, that executable contains debug info. Stript it (using strip command) before packaging for distribution.!

!CogMsWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:30'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogMsWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/16/2011 18:06'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' ,self compilerFlagsRelease! !

!CogMsWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/16/2011 19:58'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ ' -O2 -march=pentium4 -momit-leaf-frame-pointer -maccumulate-outgoing-args -funroll-loops ',
	'-DNDEBUG -DDEBUGVM=0'! !

!CogMsWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/16/2011 16:53'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogMsWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/16/2011 18:37'!
defaultExternalPlugins

	^ #(
		ReentrantIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!CogMsWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/16/2011 18:40'!
defaultInternalPlugins

	^ #(
	
ADPCMCodecPlugin 
AsynchFilePlugin
B3DAcceleratorPlugin 
BalloonEnginePlugin "B2DPlugin" 
BitBltSimulation "BitBltPlugin"
BMPReadWriterPlugin 
CroquetPlugin 
DeflatePlugin  "ZipPlugin"
DropPlugin 
DSAPlugin "DSAPrims" 
FFTPlugin 
FilePlugin 
FloatArrayPlugin 
FloatMathPlugin 
HostWindowPlugin 
IA32ABIPlugin "IA32ABI"
JoystickTabletPlugin 
JPEGReaderPlugin 
JPEGReadWriter2Plugin 
KlattSynthesizerPlugin "Klatt"
LargeIntegersPlugin "LargeIntegers"
LocalePlugin 
Matrix2x3Plugin 
MIDIPlugin 
MiscPrimitivePlugin 
Mpeg3Plugin 
RePlugin 
SecurityPlugin 
SerialPlugin 
SocketPlugin 
SoundCodecPlugin "SoundCodecPrims"
SoundGenerationPlugin 
StarSqueakPlugin 
SurfacePlugin 
UUIDPlugin

	)! !

!CogMsWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogMsWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/17/2011 02:02'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!CogMsWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/17/2011 02:35'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!CogMsWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/25/2011 22:08'!
extraSources

	^ 
	'${resources}'! !

!CogMsWindowsConfig methodsFor: 'settings' stamp: 'IgorStasenko 3/25/2011 22:24'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!CogMsWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:23'!
iconFileName
	^ 'Cog.ico'! !

!CogMsWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:27'!
interpreterClass
	^ CoInterpreter! !

!CogMsWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/16/2011 16:58'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!CogMsWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/20/2011 03:15'!
prepareForGeneration

	CrLfFileStream defaultToLF. "For strange reason it works like that"

	^ self prepareForCogGeneration! !

!CogMsWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:22'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!CogMsWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:22'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!CogMsWindowsConfig methodsFor: 'utils' stamp: 'IgorStasenko 3/17/2011 02:27'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
! !

CogMsWindowsConfig subclass: #MTCogMsWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!MTCogMsWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/17/2011 23:35'!
compilerFlags
	^ super compilerFlags, ' -DCOGMTVM=1'! !

!MTCogMsWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 23:33'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!MTCogMsWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/17/2011 23:38'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!MTCogMsWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/17/2011 23:38'!
defaultExternalPlugins

	^ #(
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!MTCogMsWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:25'!
executableName
	^ 'CogMTVM'! !

!MTCogMsWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:37'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

CogMsWindowsConfig subclass: #StackInterpreterMsWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!StackInterpreterMsWindowsConfig commentStamp: 'IgorStasenko 3/17/2011 02:53' prior: 0!
StackInterpreterMsWindowsConfig generateWithSources.

Configuration for building Stack-based VM on Win32 platform.!

!StackInterpreterMsWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/17/2011 02:51'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackInterpreterMsWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/17/2011 02:52'!
executableName
	^ 'StackVM'! !

!StackInterpreterMsWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:36'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!StackInterpreterMsWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:36'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 00:59'!
generate

	^ self new generate! !

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 00:58'!
generateWithSources

	^ self new generateSources; generate.
! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/18/2011 14:55'!
buildDir
	
	^ buildDir ifNil: [ buildDir := (self topDir / 'build') assureExistence ].
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 02:28'!
buildDir: anObject
	"Set the value of buildDir"

	buildDir := anObject! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 08:09'!
cMakeMacros
	^nil	! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:30'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ nil! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:15'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	maker 
		addCrossSources: #( 'sqOpenGLRenderer.c' ) 
	
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/27/2010 14:00'!
configureBochsIA32Plugin: maker

	"this stuff is not ready for use yet" 
	
" 	maker addCrossSources:
		#( 'sqBochsIA32Plugin.cpp'  )

"
	maker doNotGenerate:true! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"
	maker addCrossSources: #('tribox.c').! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:17'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	" it is incomplete right now, because in Cog this plugin are not used anymore"
	maker doNotGenerate: true.
	maker addCrossSources: #('sqFFIPlugin.c').! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 04:07'!
configureFT2Plugin: maker 
	"extra rules for FT2Plugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:17'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	maker addCrossSources: #( 'sqFilePluginBasicPrims.c').
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/30/2010 22:35'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations"
	maker addDefinitions: '-O0 -mno-fused-madd'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].
	
	"On *nix & mac with -DNO_ISNAN "
	maker puts:'
if (${WIN32})
	add_definitions(-Werror-implicit-function-declaration)	
else(${WIN32})
	add_definitions(-DNO_ISNAN)
endif (${WIN32})'.

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:18'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:32'!
configureIA32ABIPlugin: maker
	"extra rules for IA32ABIPlugin"

	maker addCrossSources:
		#( 'ia32abicc.c')
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:18'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:34'!
configureJPEGReadWriter2Plugin: maker 
	"extra rules for JPEGReadWriter2Plugin"

maker addCrossSources: #(
'Error.c'
'jcapimin.c'
'jcapistd.c'
'jccoefct.c'
'jccolor.c'
'jcdctmgr.c'
'jchuff.c'
'jcinit.c'
'jcmainct.c'
'jcmarker.c'
'jcmaster.c'
'jcomapi.c'
'jcparam.c'
'jcphuff.c'
'jcprepct.c'
'jcsample.c'
'jctrans.c'
'jdapimin.c'
'jdapistd.c'
'jdatadst.c'
'jdatasrc.c'
'jdcoefct.c'
'jdcolor.c'
'jddctmgr.c'
'jdhuff.c'
'jdinput.c'
'jdmainct.c'
'jdmarker.c'
'jdmaster.c'
'jdmerge.c'
'jdphuff.c'
'jdpostct.c'
'jdsample.c'
'jdtrans.c'
'jerror.c'
'jfdctflt.c'
'jfdctfst.c'
'jfdctint.c'
'jidctflt.c'
'jidctfst.c'
'jidctint.c'
'jidctred.c'
'jmemdatadst.c'
'jmemdatasrc.c'
'jmemmgr.c'
'jmemnobs.c'
'jquant1.c'
'jquant2.c'
'jutils.c'
) 
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/15/2011 15:38'!
configureMpeg3Plugin: maker
	"extra rules for Mpeg3Plugin"

	maker includeDirectories: '${pluginCross}/libmpeg ${pluginCross}/libmpeg/audio ${pluginCross}/libmpeg/video'.

	maker addCrossSources: 
		#( 
		'libmpeg/bitstream.c' 
		'libmpeg/changesForSqueak.c'
		'libmpeg/audio/dct.c'
		'libmpeg/video/getpicture.c'
		'libmpeg/audio/header.c'
		'libmpeg/video/headers.c'
		'libmpeg/video/idct.c'
		'libmpeg/audio/layer1.c'
		'libmpeg/audio/layer2.c'
		'libmpeg/audio/layer3.c'
		'libmpeg/libmpeg3.c'
		'libmpeg/video/macroblocks.c'
		'libmpeg/video/mmxtest.c'
		'libmpeg/video/motion.c'
		'libmpeg/mpeg3atrack.c'
		'libmpeg/audio/mpeg3audio.c'
		'libmpeg/mpeg3demux.c'
		'libmpeg/mpeg3io.c'
		'libmpeg/mpeg3title.c'
		'libmpeg/video/mpeg3video.c'
		'libmpeg/mpeg3vtrack.c'
		'libmpeg/video/output.c'
		'libmpeg/audio/pcm.c'
		'libmpeg/video/reconstruct.c'
		'libmpeg/video/seek.c'
		'libmpeg/video/slice.c'
		
		'libmpeg/audio/synthesizers.c'
		'libmpeg/audio/tables.c'
		'libmpeg/video/vlc.c'
	).
	
	
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/29/2010 15:41'!
configurePlugin: aPlugin with: generator

	^ self perform: ( 'configure' , aPlugin name , ':' ) asSymbol with: generator.
	! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:37'!
configureRePlugin: maker 
	"extra rules for RePlugin"

	maker addCrossSources: #(
		'pcre.c' 'study.c' 'get.c' 'chartables.c').
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/15/2011 17:25'!
configureReentrantIA32FFIPlugin: maker
	"extra rules for ReentrantIA32FFIPlugin"
	
	maker addCrossSources: #(
		'sqFFIPlugin.c' 'sqFFITestFuncs.c' 'sqManualSurface.c'
	).

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 14:19'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:40'!
configureSoundCodecPlugin: maker 
	"extra rules for SoundCodecPlugin"

	maker addCrossSources:
		#( 'sqSoundCodecPluginBasicPrims.c' )


! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:41'!
configureSurfacePlugin: maker 
	"extra rules for SurfacePlugin"

	maker set: #sources toString: ''. "remove default source file"
	maker addCrossSources: #('SurfacePlugin.c')


! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 23:40'!
configureThreadedIA32FFIPlugin: maker
	"extra rules for ThreadedIA32FFIPlugin"
	
	maker addCrossSources: #(
		'sqFFIPlugin.c' 'sqFFITestFuncs.c' 'sqManualSurface.c'
	).

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:23'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/31/2010 01:12'!
configureUnixOSProcessPlugin: maker
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	
	
	
	"THIS IS UGLY AND LAME!!!!!! "
	maker set: #linkFlags toString: '-undefined dynamic_lookup'! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:03'!
coreSources
	^#()! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 10:52'!
crossSources 
	^#(
			'sqHeapMap.c'
			'sqTicker.c'
			'sqExternalSemaphores.c'
			'sqNamedPrims.c'
			'sqVirtualMachine.c'
		)! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:19'!
defaultExternalPlugins
	self shouldBeImplemented ! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
defaultInternalPlugins
	self shouldBeImplemented ! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/14/2011 16:46'!
dirFrom: aStringOrDir
	
	^ aStringOrDir isString ifTrue: [
		FileDirectory on: ( FileDirectory fullPathForURI: aStringOrDir)] 
	ifFalse: [ aStringOrDir ]! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 12/25/2010 03:48'!
doesNotUnderstand: aMessage
	" ignore configureXYZ: messages "

	| sel  |
	sel := aMessage selector.
	
	((sel beginsWith: 'configure') and: [
		(sel indexOf: $: ) = sel size ] ) ifTrue: [ ^ self ].
	
	^ super doesNotUnderstand: aMessage! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 19:53'!
executableName
	"default one"
	^ 'Squeak'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 22:44'!
executableType
	^ ''! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:16'!
externalPlugins
	^ externalPlugins ifNil: [ externalPlugins := self defaultExternalPlugins ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
externalPlugins: aColl

	externalPlugins := aColl! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/15/2011 15:34'!
extraPluginSettings: maker
	"override in subclasses to apply extra settings for all plugins targets"! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:04'!
extraSources
	^''! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 12/23/2010 11:54'!
fixLineEndsOf: string
	^ string ! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 00:52'!
frameworks
	"leave empty for all platforms but Mac OS"
	^ #()! !

!CPlatformConfig methodsFor: 'public' stamp: 'IgorStasenko 3/5/2011 14:17'!
generate
	^ CMakeVMGenerator generate: self ! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/3/2011 12:09'!
generateSources
	"Generate whole VM + plugins sources"
	| maker |

	self validateSourcesPresent.
	self prepareForGeneration.
	
	"suppress questions and deprecation warnings during generation "
	[[
		
		maker := self prepareVMMaker.
	
		maker interpreterClass: self interpreterClass.
		self cogitClass ifNotNil: [:cg | maker cogitClass: cg ].

	
		maker generateEntire

	] on: ProvideAnswerNotification do: [:ex | ex resume: true ]]
	on: Deprecation do: [:ex | ex resume ].
	
	
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 2/16/2011 11:26'!
generateStackSources
	" generate sources for Stack Interpreter"

	StackInterpreter initialize.
	
	VMMaker
		generate: StackInterpreter
		to: self srcDir fullName
		platformDir: self platformsDir fullName
		excluding: #(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
			FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin).! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:16'!
internalPlugins
	^ internalPlugins ifNil: [ internalPlugins := self defaultInternalPlugins ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
internalPlugins: aColl

	internalPlugins := aColl! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:25'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'testing' stamp: 'Igor.Stasenko 12/30/2010 22:29'!
isLittleEndian
	"default is true. Override if necessary"
	^ true! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/20/2011 14:16'!
linkFlags 
	^''! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:03'!
platformSources
	^#()! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'IgorStasenko 2/10/2011 11:09'!
platformsDir
	"by default , answer the {topdir}/platforms subdir"

	^ platformsDir ifNil: [ platformsDir := self topDir / 'platforms' ]! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 03:37'!
platformsDir: anObject
	"Set the value of platformsDir"

	platformsDir := anObject! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 12:03'!
pluginsDir 
	^pluginsDir
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/14/2011 16:48'!
pluginsDir: aStringOrDir
	"Set the value of topDir"

	pluginsDir := self dirFrom: aStringOrDir.
	! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:14'!
preferredIncludes
	^#()! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:28'!
prepareForCogGeneration.
	"make sure these classes are initialized properly "	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:26'!
prepareForGeneration
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:35'!
prepareForStackVMGeneration
	"make sure these classes are initialized properly "	
		
	StackInterpreter initialize
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 01:16'!
prepareVMMaker

	| maker allPlugins |
	
	maker := VMMaker forPlatform: 'Cross'.
	maker sourceDirectoryName: (self srcDir assureExistence fullName).
	maker platformRootDirectoryName: (self topDir / 'platforms' ) fullName.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/15/2011 17:00'!
setExtraTargetProperties: maker

! !

!CPlatformConfig methodsFor: 'directories' stamp: 'EstebanLorenzano 3/4/2011 12:21'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (buildDir ifNil: ['${topDir}/build']);
			set: #platformsDir toString: self platformsDir fullName;
			set: #srcDir toString: self srcDir fullName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm'.
	].

	self write: dirsInclude toFile: 'directories.cmake'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/28/2011 15:57'!
srcDir
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := self topDir / 'src' ]! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/14/2011 16:47'!
srcDir: aStringOrDir
	"Set the value of topDir"

	srcDir := self dirFrom: aStringOrDir.
	! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:04'!
standardIncludes 
	^#()! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/15/2011 15:21'!
topDir
	
	^ topDir ifNil: [ topDir := FileDirectory default containingDirectory ].
! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/14/2011 17:22'!
topDir: pathString

	topDir :=
		FileDirectory on: (FileDirectory fullPathForURI: pathString).
	topDir assureExistence.! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/3/2011 12:10'!
validateSourcesPresent
	| sources |
	sources := FileDirectory openSources: SmalltalkImage current sourcesName forImage: SmalltalkImage current imageName.
	
	((sources == nil or: [sources atEnd])
			and: [ SmalltalkImage current checkSourcesFileAvailability])
		ifTrue: [
		self error: 'VM source code cannot be generated without .sources file'.
	]		! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/15/2011 15:22'!
write: aContents toFile: aFileName

	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"
	

	| bldDir |
	
	bldDir := self buildDir.
	
 	bldDir isString ifTrue: [ bldDir := FileDirectory on: (FileDirectory fullPathForURI: bldDir) ].
	bldDir assureExistence.
	
	bldDir forceNewFileNamed: aFileName 
		do: [:stream | stream nextPutAll: (self fixLineEndsOf: aContents) ].! !

CPlatformConfig subclass: #CUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CUnixConfig commentStamp: 'IgorStasenko 3/15/2011 17:33' prior: 0!
For ALSA sound driver you need to install a 

 - libasound2
 - libasound2-dev

For UUID you might also need: 

- uuid-dev
 packages  


!

!CUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:45'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "', self linkFlags , '"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CUnixConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/18/2011 17:43'!
addVMDrivers: maker

	 self 
		addDriver: 'vm-display-null' 
		sources: #( 
			'${targetPlatform}/vm-display-null/sqUnixDisplayNull' )
		generator: maker;
		
		addDriver: 'vm-display-X11' 
		sources: #( 
			'${targetPlatform}/vm-display-X11/sqUnixX11'
			'${targetPlatform}/vm-display-X11/sqUnixMozilla' )
		generator: maker;
		
		addDriver: 'vm-sound-ALSA' 
		sources: #( 
			'${targetPlatform}/vm-sound-ALSA/sqUnixSoundALSA' )
		generator: maker;

		addDriver: 'vm-sound-null' 
		sources: #( 
			'${targetPlatform}/vm-sound-null/sqUnixSoundNull' )
		generator: maker.
	
"
vm-display-null
	vm-display-X11
	vm-sound-ALSA
	vm-sound-null"! !

!CUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags
	^ self subclassResponsibility! !

!CUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/16/2011 01:28'!
configureAsynchFilePlugin: maker

	maker addPlatformSources:
	#( 
		'sqUnixAsynchFile.c'
	)

! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 14:29'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.
	
	maker 
		addPlatformSources: #( 'sqUnixOpenGL.c' ) 
		
! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:50'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'. 
	maker addPlatformSources: #( 'sqUnixDragDrop')
! !

!CUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/16/2011 01:59'!
configureFileCopyPlugin: maker
	"extra rules for DropPlugin"

	maker addPlatformSources: #( 'sqUnixFileCopyPlugin')
! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:31'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker addPlatformSources: #( 'sqUnixFile')! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:34'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 'sqUnixJoystickTablet' )
! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:37'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  

	"requires ALSA"

	maker addPlatformSources: #( 'sqUnixMIDI')! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:38'!
configureSecurityPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqUnixSecurity')! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:40'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"
	
	maker addPlatformSources: #( 'sqUnixSerial')! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:41'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
	
	maker addPlatformSources: #( 'sqUnixSocket')! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:42'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
	
	maker addPlatformSources: #( 'sqUnixSound')! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/15/2011 17:56'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	
	maker includeDirectories: '/usr/include/uuid'.
	
	maker addPlatformSources:
		#( 'sqUnixUUID.c')


! !

!CUnixConfig methodsFor: 'plugin extra rules' stamp: 'NicolasPasserini 3/30/2011 16:42'!
extraPluginSettings: maker

	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir

	].
! !

!CUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/18/2011 10:48'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.
	
	maker cmd: 'add_custom_command' params: 'OUTPUT ',
		versionC , '
		COMMAND ${platformsDir}/unix/config/verstamp ',versionC,' gcc
		COMMENT "Generating version.c"
	'.
	
	! !

!CUnixConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/18/2011 10:16'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!CUnixConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/4/2011 02:37'!
frameworks
	^ #()! !

!CUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:46'!
linkFlags
	 ^ '-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'! !

!CUnixConfig methodsFor: 'directories' stamp: 'IgorStasenko 2/9/2011 19:02'!
outputDir

	"the directory where built binaries will be stored"
	
	^ self buildDir fullName , '/results'! !

!CUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/4/2011 02:38'!
platformName
	^ 'unix'! !

!CUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 2/9/2011 19:04'!
setExtraTargetProperties: maker


	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'dl'  "dynamic loader"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	self addVMDrivers: maker.! !

CUnixConfig subclass: #CogUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!CogUnixConfig commentStamp: 'IgorStasenko 2/10/2011 18:08' prior: 0!
Base configuration for building Cog VM on Unix platform(s).

Usage: 
CogUnixConfig generateWithSources
or
CogUnixConfig generate   "if VMMaker sources already there"!

CogUnixConfig subclass: #CogDebugUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!CogDebugUnixConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

CogUnixConfig subclass: #CogFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD-Cog'!

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 05:08'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-pthread -lm"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 21:09'!
addVMDrivers: maker

	 self 
		addDriver: 'vm-display-null' 
		sources: #( 
			'${targetPlatform}/vm-display-null/sqUnixDisplayNull' )
		generator: maker;
		
		addDriver: 'vm-display-X11' 
		sources: #( 
			'${targetPlatform}/vm-display-X11/sqUnixX11'
			'${targetPlatform}/vm-display-X11/sqUnixMozilla' )
		generator: maker;
		
		addDriver: 'vm-sound-null' 
		sources: #( 
			'${targetPlatform}/vm-sound-null/sqUnixSoundNull' )
		generator: maker.
	
"
vm-display-null
	vm-display-X11
	vm-sound-null"! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 04:57'!
compilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ super compilerFlags, ' -I/usr/local/include'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 05:01'!
compilerFlagsDebug

	^ '-g3 -O1 -msse2  -DDEBUG -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=1 -DNOEXECINFO'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 15:23'!
compilerFlagsRelease

	^ '-g -O2 -msse2  -DNDEBUG -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=0 -DNOEXECINFO'
! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 21:22'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define HAVE_INTERP_H 1

/* package options */

#define USE_X11 1
#define USE_X11_GLX 1
/* #undef       USE_QUARTZ */
/* #undef       USE_QUARTZ_CGL */
/* #undef       USE_RFB */

/* libraries */

/* #undef       HAVE_LIBX11 */
#define HAVE_LIBXEXT 1
#define HAVE_LIBDL 1
/* #undef       HAVE_DYLD */
/* #undef       HAVE_LIBFFI */
/* #undef       HAVE_ICONV */

/* #undef       USE_AUDIO_NONE */
/* #undef       USE_AUDIO_SUN */
/* #undef       USE_AUDIO_NAS */
/* #undef       USE_AUDIO_OSS */
/* #undef       USE_AUDIO_MACOSX */
/* #undef       OSS_DEVICE */

/* header files */

#define HAVE_UNISTD_H 1
/* #undef       NEED_GETHOSTNAME_P */

#define HAVE_DIRENT_H 1
/* #undef       HAVE_SYS_NDIR_H */
/* #undef       HAVE_SYS_DIR_H */
/* #undef       HAVE_NDIR_H */
#define HAVE_DLFCN_H 1
/* #undef       HAVE_ICONV_H */

#define HAVE_SYS_TIME_H 1
#define TIME_WITH_SYS_TIME 1

#define HAVE_SYS_FILIO_H 1

/* #undef       HAVE_SYS_AUDIOIO_H */
/* #undef       HAVE_SUN_AUDIOIO_H */

/* #undef       HAVE_PTY_H */
/* #undef       HAVE_UTIL_H */
#define HAVE_LIBUTIL_H 1
/* #undef       HAVE_STROPTS_H */

#define HAVE_GL_GL_H 1
/* #undef       HAVE_OPENGL_GL_H */

/* #undef       NEED_SUNOS_H */


#define HAVE_UUID_H
/* system calls/library functions */

#define AT_EXIT atexit

#define HAVE_TZSET 1

#define HAVE_OPENPTY 1
/* #undef       HAVE_UNIX98_PTYS */

#define HAVE_SNPRINTF 1
/* #undef       HAVE___SNPRINTF */

#define HAVE_MMAP 1

/* #undef       HAVE_DYLD */

#define HAVE_LANGINFO_CODESET 1

#define HAVE_ALLOCA 1
/* #undef       HAVE_ALLOCA_H */

#define HAVE_UNSETENV 1

#define HAVE_NANOSLEEP 1

/* widths of primitive types */

#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOID_P 4

/* structures */

#define HAVE_TM_GMTOFF 1
#define HAVE_TIMEZONE 1

/* typedefs */

/* #undef       size_t */
/* #undef       socklen_t */

#define squeakInt64 long long

/* architecture */

#define OS_TYPE "unix"

#define VM_HOST "i386-freebsd8.2"
#define VM_HOST_CPU "i386"
/* #undef       VM_HOST_VENDOR */
#define VM_HOST_OS "freebsd8.2"
#define VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef       WORDS_BIGENDIAN */
/* #undef       DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef       DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR "/usr/X11R6/lib"

/* avoid dependencies on glibc2.3 */

/* #undef HAVE_FEATURES_H */

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 18:13'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations
	# 3/25/11 - DSG Removed -mno-fused-madd
	since FreeBSD will not support > GCC42"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].
	
	"On *nix & mac with -DNO_ISNAN "
	maker puts:'
if (${WIN32})
	add_definitions(-Werror-implicit-function-declaration)	
else(${WIN32})
	add_definitions(-DNO_ISNAN)
endif (${WIN32})'.

! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 03:36'!
setExtraTargetProperties: maker


	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	self addVMDrivers: maker.! !

CogFreeBSDConfig subclass: #MTCogFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD-Cog'!

!MTCogFreeBSDConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/23/2011 15:34'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=1'	
	! !

!MTCogFreeBSDConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/23/2011 15:34'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!MTCogFreeBSDConfig methodsFor: 'sources' stamp: 'IgorStasenko 3/23/2011 15:34'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!MTCogFreeBSDConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/23/2011 15:34'!
defaultExternalPlugins

	^ #(
		B3DAcceleratorPlugin
		UUIDPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UnixOSProcessPlugin ?? "
	)! !

!MTCogFreeBSDConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:34'!
executableName
	^ 'CogMTVM'! !

!MTCogFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:34'!
interpreterClass
	^ CoInterpreterMT! !

CogFreeBSDConfig subclass: #StackInterpreterFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD-Cog'!

!StackInterpreterFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/23/2011 15:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackInterpreterFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:37'!
interpreterClass
	^ StackInterpreter! !

!StackInterpreterFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:37'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:38'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'NicolasPasserini 3/30/2011 14:08'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=0 -m32' 	
	! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:55'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' ,self compilerFlagsRelease! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/19/2011 23:56'!
compilerFlagsDebug

	^ '-g3 -O1 -msse2 -D_GNU_SOURCE -DDEBUG -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DDEBUGVM=1'

! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/19/2011 23:55'!
compilerFlagsRelease

	^ '-g -O2 -msse2 -D_GNU_SOURCE -DNDEBUG -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=0'

! !

!CogUnixConfig methodsFor: 'headers generation' stamp: 'IgorStasenko 3/15/2011 17:54'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/7/2011 17:10'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogUnixConfig methodsFor: 'plugins' stamp: 'NicolasPasserini 3/30/2011 16:14'!
defaultExternalPlugins
	^ #(
		B3DAcceleratorPlugin
		ReentrantIA32FFIPlugin "SqueakFFIPrims"
		"UUIDPlugin"
		"UnixOSProcessPlugin ?? "	
	)! !

!CogUnixConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/15/2011 15:33'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin 
		CroquetPlugin 
		DeflatePlugin  "ZipPlugin"
		DropPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		IA32ABIPlugin "IA32ABI"
		JoystickTabletPlugin 
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin 
		RePlugin 	
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin	
		)! !

!CogUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogUnixConfig methodsFor: 'plugin extra rules' stamp: 'NicolasPasserini 3/30/2011 16:43'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
	maker puts: 'list(APPEND linkFlags "-m32")'
! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/18/2011 10:45'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'version.c'! !

!CogUnixConfig methodsFor: 'headers generation' stamp: 'Igor.Stasenko 1/15/2011 14:55'!
generateConfigH
	"will fix that later"
	self write: self configH toFile: 'config.h'! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:37'!
interpreterClass
	^ CoInterpreter! !

!CogUnixConfig methodsFor: 'accessing' stamp: 'NicolasPasserini 3/30/2011 16:48'!
linkFlags 
	^ super linkFlags , ' -m32'! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/16/2011 00:53'!
platformSources
	"files added from platform/unix/vm dir "
	^ #(
	'aio.c'
	'debug.c'
"	'dlfcn-dyld.c'
	'mac-alias.c' "
	'osExports.c'
	'sqUnixCharConv.c'
"	'sqUnixEvent.c' "
	'sqUnixExternalPrims.c'
	'sqUnixHeartbeat.c'
	'sqUnixMain.c'
	'sqUnixMemory.c'
	'sqUnixThreads.c'
	'sqUnixVMProfile.c'
	)! !

!CogUnixConfig methodsFor: 'source files' stamp: 'IgorStasenko 2/9/2011 20:21'!
preferredIncludes
	^ #( '${targetPlatform}/plugins/B3DAcceleratorPlugin')
	! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:35'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForCogGeneration
! !

!CogUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:40'!
setExtraTargetProperties: maker

	maker setTargetProperties: 'LINK_FLAGS "-m32"'.
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer -mno-rtd -mno-accumulate-outgoing-args")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -mno-rtd -mno-accumulate-outgoing-args"'.
						
	super setExtraTargetProperties: maker.
! !

CogUnixConfig subclass: #CogUnixNoGLConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!CogUnixNoGLConfig commentStamp: 'IgorStasenko 3/18/2011 02:36' prior: 0!
A slightly modified configuration, which avoids linking with openGL libraries.!

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/4/2011 12:41'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-lSM -lICE -ldl -lpthread -lm -lnsl -lX11"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/4/2011 12:39'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1

#undef	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#undef	HAVE_GL_GL_H 1
#undef	HAVE_OPENGL_GL_H 

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

CogUnixConfig subclass: #MTCogUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!MTCogUnixConfig methodsFor: 'compiler flags' stamp: 'NicolasPasserini 3/30/2011 17:02'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=1 -m32' 	
	! !

!MTCogUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/19/2011 23:56'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!MTCogUnixConfig methodsFor: 'sources' stamp: 'IgorStasenko 3/19/2011 23:56'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!MTCogUnixConfig methodsFor: 'plugins' stamp: 'NicolasPasserini 3/30/2011 17:19'!
defaultExternalPlugins

	^ #(
		B3DAcceleratorPlugin
		"UUIDPlugin"
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UnixOSProcessPlugin ?? "
	)! !

!MTCogUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!MTCogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/19/2011 23:56'!
interpreterClass
	^ CoInterpreterMT! !

CogUnixConfig subclass: #StackInterpreterUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!StackInterpreterUnixConfig commentStamp: 'IgorStasenko 2/10/2011 17:54' prior: 0!
Usage: 
StackInterpreterUnixConfig generateWithSources!

StackInterpreterUnixConfig subclass: #StackInterpreterDebugUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!StackInterpreterDebugUnixConfig commentStamp: 'IgorStasenko 2/10/2011 18:00' prior: 0!
To generate Stack-based interpreter unix VM with debug info.


Usage: 
StackInterpreterDebugUnixConfig generateWithSources!

StackInterpreterDebugUnixConfig subclass: #FixedVerSIDebugUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix-Cog'!

!FixedVerSIDebugUnixConfig commentStamp: 'IgorStasenko 2/10/2011 19:45' prior: 0!
This is done specifically to track down the instability issues of Cog VM on UNIX

!

!FixedVerSIDebugUnixConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/10/2011 19:44'!
compilerFlagsDebug

	^ '-g3 -O1 -msse2 -save-temps -D_GNU_SOURCE -DDEBUG -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DCOGMTVM=0 -DDEBUGVM=1'

! !

!FixedVerSIDebugUnixConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/10/2011 19:43'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	
	"output a fake version.c file"
	
	self write:
'int vm_serial= 1;
char *vm_date= "<HERE IS SUPPOSED TO BE THE DATE>";
char *cc_version= "<HERE IS SUPPOSED TO BE gcc VERSION>";
char *ux_version= "<FAKE FROZEN VERSION FOR DEBUGGING PURPOSES>";
'
	toFile: 'version.c'.
! !

!StackInterpreterDebugUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

!StackInterpreterUnixConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/10/2011 11:24'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackInterpreterUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:35'!
interpreterClass
	^ StackInterpreter! !

!StackInterpreterUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:35'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

CPlatformConfig subclass: #MacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

MacOSConfig subclass: #CocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

CocoaIOSConfig subclass: #CocoaIOSCogConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CocoaIOSCogConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 3/18/2011 12:05'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!CocoaIOSCogConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/24/2011 09:23'!
compilerFlagsRelease 
	^#('-g3' '-O3' '-fvisibility=hidden' '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-fomit-frame-pointer' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DBUILD_FOR_OSX' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DNDEBUG=1' '-DDEBUGVM=0' '-DCOGMTVM=0' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4')! !

!CocoaIOSCogConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/23/2011 12:23'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.! !

!CocoaIOSCogConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 2/5/2011 09:28'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/HostWindowPlugin'.! !

!CocoaIOSCogConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:15'!
crossSources 
	^super crossSources, #(
	'sqExternalSemaphores.c'
	'sqHeapMap.c'
	'sqTicker.c')! !

!CocoaIOSCogConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/1/2011 14:20'!
defaultExternalPlugins 
	^(Array with: self ffiPluginName),
		#(
		UUIDPlugin
		FloatMathPlugin
		AsynchFilePlugin
		SerialPlugin
		Mpeg3Plugin
		CroquetPlugin
		JoystickTabletPlugin
		MIDIPlugin
		B3DAcceleratorPlugin)! !

!CocoaIOSCogConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/23/2011 12:34'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		"B3DAcceleratorPlugin"
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		"ClipboardExtendedPlugin" 
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		"FFIPlugin" "FFI Stuff needs to be external"
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		MacMenubarPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		"IA32ABIPlugin" 
		"ObjectiveCPlugin" 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		StarSqueakPlugin 
		SurfacePlugin 
		"UUIDPlugin")! !

!CocoaIOSCogConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/17/2011 17:20'!
extraSources
	" mac VM using some unix sources "
	
	^super extraSources,'
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/vm/sqUnixHeartbeat.c 
	${platformsDir}/unix/vm/sqUnixVMProfile.c 
	${platformsDir}/unix/vm/sqUnixThreads.c '! !

!CocoaIOSCogConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 13:39'!
ffiPluginName 
	^#FFIPlugin ! !

!CocoaIOSCogConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:15'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		"'Common/aio.c'"
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXNSView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c'
	  	'Common/Classes/sqSqueakScreenAPI.m')! !

!CocoaIOSCogConfig methodsFor: 'settings' stamp: 'IgorStasenko 3/18/2011 17:26'!
setExtraTargetProperties: maker
	| plist |

	maker addFrameworks: self frameworks.

	" generated and add Info.plist file "
	plist := self plistFile.

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
			
	(maker buildDir forceNewFileNamed: self prefixHeaderFileName) 
		nextPutAll: self precompiledHeaders;
		close.
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', self prefixHeaderFileName.

	maker 
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-DLSB_FIRST -mfpmath=sse -finline-functions  -fomit-frame-pointer -fno-cse-follow-jumps -fno-gcse -mtune=prescott -march=pentium-m -falign-functions=16'.
		
	maker 
		addXCodeProperty: 'GCC_VERSION' value: '4.2'.

	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self topDir / 'build' / self prefixHeaderFileName) fullName, '\""'. 
	! !

!CocoaIOSCogConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/22/2011 17:31'!
standardIncludes
	^#(
	'${srcDir}/vm'
	'${platformsDir}/iOS/vm/OSX'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/HostWindowPlugin'
	'${platformsDir}/Cross/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' "Sources are here :("
	'${crossDir}/plugins/FilePlugin'
	)	
! !

CocoaIOSCogConfig subclass: #CocoaIOSCogJitConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CocoaIOSCogJitConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:46'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CocoaIOSCogJitConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/5/2011 10:02'!
compilerFlagsRelease 
	^super compilerFlagsRelease, #('-DCOGVM')! !

!CocoaIOSCogJitConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/27/2011 18:13'!
coreSources 
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CocoaIOSCogJitConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CocoaIOSCogJitConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 13:39'!
ffiPluginName 
	^#ReentrantIA32FFIPlugin! !

!CocoaIOSCogJitConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
interpreterClass
	^ CoInterpreter! !

!CocoaIOSCogJitConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/28/2011 15:33'!
pluginsDir 
	^'${topDir}/src/plugins'! !

!CocoaIOSCogJitConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForCogGeneration
! !

!CocoaIOSCogJitConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/4/2011 12:21'!
srcDir 
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := self topDir / 'src' ]! !

CocoaIOSCogJitConfig subclass: #MTCocoaIOSCogJitConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!MTCocoaIOSCogJitConfig commentStamp: 'IgorStasenko 3/18/2011 16:26' prior: 0!
This config for building Thread-aware VM and threaded FFI!

!MTCocoaIOSCogJitConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/24/2011 09:09'!
compilerFlagsRelease 
	^#('-g3' '-O3' '-fvisibility=hidden' '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-fomit-frame-pointer' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DBUILD_FOR_OSX' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DNDEBUG=0' '-DDEBUGVM=1' '-DCOGMTVM=1' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4' '-DCOGVM')! !

!MTCocoaIOSCogJitConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/18/2011 16:26'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!MTCocoaIOSCogJitConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!MTCocoaIOSCogJitConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 13:40'!
ffiPluginName 
	^#ThreadedIA32FFIPlugin! !

!MTCocoaIOSCogJitConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 16:24'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

CocoaIOSCogConfig subclass: #CocoaIOSCogStackConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

CocoaIOSCogStackConfig subclass: #CLANGCocoaIOSCogStackConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CLANGCocoaIOSCogStackConfig commentStamp: 'IgorStasenko 3/23/2011 15:21' prior: 0!
Experimental configuration for compiling using clang compiler!

!CLANGCocoaIOSCogStackConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 18:30'!
coreSources 
" can't use GCC stuff "
	^ #(
		'interp.c'
		)! !

!CLANGCocoaIOSCogStackConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 18:32'!
setExtraTargetProperties: maker


	maker set: 'CMAKE_C_COMPILER' to: 'clang'.
	
	super setExtraTargetProperties: maker! !

!CocoaIOSCogStackConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/5/2011 10:02'!
compilerFlagsRelease 
	^super compilerFlagsRelease, #('-DSTACKVM')! !

!CocoaIOSCogStackConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:40'!
coreSources 
	^ #(
		'gcc3x-interp.c'
		)! !

!CocoaIOSCogStackConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/18/2011 15:36'!
executableName
	^ 'StackVM'! !

!CocoaIOSCogStackConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 13:40'!
ffiPluginName 
	^#ReentrantIA32FFIPlugin! !

!CocoaIOSCogStackConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
interpreterClass
	^ StackInterpreter! !

!CocoaIOSCogStackConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/5/2011 09:19'!
pluginsDir 
	^'${topDir}/stacksrc/plugins'! !

!CocoaIOSCogStackConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

!CocoaIOSCogStackConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/4/2011 12:20'!
srcDir 
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := self topDir / 'stacksrc' ]! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleExecutable
	^ self executableName ! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleGetInfoString
	^ self CFBundleShortVersionString
! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/3/2011 20:17'!
CFBundleIconFile
	"An application icon"
	^ 'Squeak.icns'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:12'!
CFBundleIdentifier
	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	^ 'org.squeakfoundation.Squeak'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleName
	"An application name"
	^ self executableName, ' (Cocoa) 32bits'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:11'!
CFBundleShortVersionString
	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:11'!
CFBundleVersion
	"An application version"
	^ '5.7.4'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/10/2011 22:08'!
NSMainNibFile
	^'MainMenu'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/23/2011 20:11'!
commonCompilerFlags
	"Common compiler flags"
	^#('-arch i386' "'-fnext-runtime'" '-mmacosx-version-min=10.5')! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/20/2011 14:40'!
compilerFlags 
	^String streamContents: [ :stream |
		(self commonCompilerFlags, self compilerFlagsRelease)
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/24/2011 09:23'!
compilerFlagsRelease 
	^#(
	"'-fobjc-direct-dispatch'" 
	'-msse3'
	"'-msse4.1'"
	"'-msse4.2'"
	"'-mdynamic-no-pic'" 
	"'-fwritable-strings'" 
	'-Os' 
	'-fvisibility=hidden' 
	'-funroll-loops' 
	"'-fno-asm'" 
	'-fasm-blocks' 
	'-finline-functions' 
	'-mfpmath=sse' 
	'-fomit-frame-pointer' 
	'-march=pentium-m' 
	'-mtune=prescott' 
	'-falign-functions=16'  
	'-fno-gcse' 
	'-fno-cse-follow-jumps' 
	'-std=gnu99' 
	'-DBUILD_FOR_OSX' 
	'-DUSE_INLINE_MEMORY_ACCESSORS' 
	'-DLSB_FIRST' 
	'-DUSE_INLINE_MEMORY_ACCESSORS' 
	'-DHAVE_SYS_TIME_H' 
	'-DHAVE_NANOSLEEP' 
	'-DICC_DEBUG=0'
	'-DICC_OPTLEVEL="speedHLO"' 
	'-DICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION=1' 
	'-DICC_OPT_PARALLEL=0' 
	'-DICC_OPT_PREFETCH_INSERTION=1' 
	'-DICC_OPT_PROVIDE_FRAME_PTR=0' 
	'-DICC_OPT_USE_ARCH_IA32="SSE42"')! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/26/2011 11:36'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	maker addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:49'!
configureClipboardExtendedPlugin: maker
	maker includeDirectories: '${platformsDir}/iOS/plugins/ClipboardExtended'.
	maker 
		addSources: #('sqMacExtendedClipboard.m' ) 
		prefixed: '${platformsDir}/iOS/plugins/ClipboardExtended/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:49'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker 
		addSources: #('sqMacHostWindow.c' ) 
		prefixed: '${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/26/2011 11:34'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/17/2011 16:57'!
configureMacMenubarPlugin: maker
	maker includeDirectories: '${platformsDir}/iOS/plugins/MacMenubarPlugin'.
	maker 
		addSources: #('MacMenuOS9ToOSX.m') 
		prefixed: '${platformsDir}/iOS/plugins/MacMenubarPlugin/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:48'!
configureSoundPlugin: maker
	super configureSoundPlugin: maker.
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/SoundPlugin ${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'.
	maker 
		addSources: #('sqSqueakSoundCoreAudio.m' 'sqSqueakSoundCoreAudioAPI.m' ) 
		prefixed: '${platformsDir}/iOS/plugins/SoundPlugin/'.
	maker 
		addSources: #('sqSqueakOSXSoundCoreAudio.m' ) 
		prefixed: '${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin/'! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:47'!
configureUUIDPlugin: maker
	super configureUUIDPlugin: maker.
	maker addSources: #('sqUnixUUID.c' ) prefixed: '${platformsDir}/unix/plugins/UUIDPlugin/'
! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 08:40'!
coreSources
	^#('interp.c')! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 20:25'!
crossSources 
	^#(
		'sqNamedPrims.c'
		'sqVirtualMachine.c')! !

!CocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 1/2/2011 09:29'!
defaultExternalPlugins
	^#()! !

!CocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 15:42'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin 
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFIPlugin
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		MacMenubarPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin)! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 14:37'!
executableType
	^ 'MACOSX_BUNDLE'! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/23/2011 15:11'!
extraPluginSettings: maker	
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.
	
	maker 
		setTargetProperty: 'COMPILE_FLAGS' 
		to: '"-include \"', (self topDir / 'build' / self prefixHeaderFileName) fullName, '\""'.  

	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir.
		maker puts: 'list(APPEND linkFlags "-undefined dynamic_lookup")' ].
	
	maker addXCodeProperty: 'GCC_VERSION' value: '4.2'.
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/' , self executableName , '_Prefix.pch'.
	
! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/17/2011 18:40'!
extraSources
	^'${buildDir}/', self prefixHeaderFileName, '
 ${resources}'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'IgorStasenko 3/18/2011 19:05'!
extraVMSettings: maker
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' to: '${topDir}/macbuild/resources/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"
		"${resourceDir}/MainMenu.nib"'
! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 19:20'!
frameworks
	^ #(
	Cocoa
	Foundation
	AudioToolbox
	CoreAudio
	SystemConfiguration
	ApplicationServices
	QuartzCore
	OpenGL)! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/22/2011 19:12'!
outputDir
	"the directory where built binaries will be stored"
	
	^ self buildDir fullName , '/results'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 07:50'!
platformName 
	^'iOS'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 20:25'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/aio.c'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXNSView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c')! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/10/2011 22:15'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier
	NSMainNibFile) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/10/2011 22:07'!
plistTemplate 
^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakImage.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakSources.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakChanges.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>FAST</string>
	<key>CFBundleVersion</key>
	<string>21.0</string>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>LSMinimumSystemVersion</key>
	<string>${MACOSX_DEPLOYMENT_TARGET}</string>
	<key>NSMainNibFile</key>
	<string>@NSMainNibFile@</string>
	<key>NSPrincipalClass</key>
	<string>SqueakOSXApplication</string>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakQuitOnQuitAppleEvent</key>
	<false/>
	<key>SqueakResourceDirectory</key>
	<string></string>
	<key>SqueakTrustedDirectory</key>
	<string>/foobar/tooBar/forSqueak/bogus/</string>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Squeak/Internet/My Squeak/</string>
	<key>SqueakUseFileMappedMMAP</key>
	<false/>
	<key>SqueakUIFadeForFullScreenInSeconds</key>
	<real>0.5</real>
	<key>UTExportedTypeDeclarations</key>
	<array>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Image File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.image</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STim</string>
				<key>public.filename-extension</key>
				<array>
					<string>image</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-image</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Sources File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.sources</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STso</string>
				<key>public.filename-extension</key>
				<array>
					<string>sources</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-sources</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Changes File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.changes</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STch</string>
				<key>public.filename-extension</key>
				<array>
					<string>changes</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-changes</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Script File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.script</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>SOBJ</string>
				<key>public.filename-extension</key>
				<array>
					<string>sobj</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-script</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Project File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.project</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STpr</string>
				<key>public.filename-extension</key>
				<array>
					<string>pr</string>
				</array>
				<key>public.mime-type</key>
				<string>application/x-squeak-project</string>
			</dict>
		</dict>
	</array>
</dict>
</plist>
'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 12:08'!
pluginsDir 
	^'${srcDir}/vm/intplugins'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/26/2011 12:09'!
precompiledHeaders 
	^
'//
// Prefix header for all source files of the ''', self executableName, ''' target in the ''', self executableName, ''' project
//

#ifdef __OBJC__
	#import <Cocoa/Cocoa.h>
#endif
'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:25'!
preferredIncludes
	^ #(
	'${buildDir}/'
	'${platformsDir}/iOS/vm/iPhone' "config.h is here. Why???"
	)
	! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/17/2011 18:40'!
prefixHeaderFileName 
	^self executableName, '_Prefix.pch'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 1/20/2011 15:22'!
setExtraTargetProperties: maker
	| plist precompiledHeaders |

	" generated and add Info.plist file "
	plist := self plistFile.

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
			
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(maker buildDir forceNewFileNamed: precompiledHeaders) 
		nextPutAll: self precompiledHeaders;
		close.
		
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.

	"maker 
		addXCodeProperty: 'GCC_ENABLE_SSE3_EXTENSIONS' value: 'YES';  
		addXCodeProperty: 'GCC_ENABLE_SSE41_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_ENABLE_SSE42_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_GENERATE_DEBUGGING_SYMBOLS' value: 'NO';  
		addXCodeProperty: 'GCC_INLINES_ARE_PRIVATE_EXTERN' value: 'YES';
		addXCodeProperty: 'GCC_UNROLL_LOOPS' value: 'YES'.	"
	
	"Extras"
	maker 
		addXCodeProperty: 'ICC_DEBUG' value: 'NO';
		addXCodeProperty: 'ICC_OPTLEVEL' value: 'speedHLO';
		addXCodeProperty: 'ICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PARALLEL' value: 'NO';
		addXCodeProperty: 'ICC_OPT_PREFETCH_INSERTION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PROVIDE_FRAME_PTR' value: 'NO';
		addXCodeProperty: 'ICC_OPT_USE_ARCH_IA32' value: 'SSE41';
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-finline-functions -mfpmath=sse -fomit-frame-pointer -march=pentium-m -mtune=prescott -falign-functions=16  -fno-gcse -fno-cse-follow-jumps  -DLSB_FIRST -DUSE_INLINE_MEMORY_ACCESSORS';
		addXCodeProperty: 'PER_ARCH_CFLAGS_ppc' value: '-fast -mtune=7450 -mcpu=7450 -D_BSD_SOCKLEN_T_=int'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 10:15'!
srcDir 
	^'${topDir}/platforms/iOS/vm/src'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:25'!
standardIncludes
	^ #(
	'${crossDir}/plugins/SerialPlugin'   
	'${targetPlatform}/plugins/FilePlugin'
	'${crossDir}/plugins/FilePlugin'
	'${targetPlatform}/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' 
	'${crossDir}/plugins/HostWindowPlugin'
	'${crossDir}/plugins/DropPlugin'
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/vm/OSX'
)
	! !

MacOSConfig subclass: #CogMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMacOSConfig commentStamp: 'IgorStasenko 3/18/2011 02:30' prior: 0!
CogMacOSConfig generateWithSources.

This is a configuration for building Cog VM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).!

CogMacOSConfig subclass: #CogDebugMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogDebugMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:37'!
compilerFlags

    ^  self compilerFlagsDebug! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:14'!
CFBundleExecutable
	^ self executableName ! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:11'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/25/2010 00:37'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:06'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/25/2010 01:36'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 19:46'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:09'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:39'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'Igor.Stasenko 12/23/2010 19:59'!
commonCompilerFlags

	"Common compiler flags"
	
	^ ' -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=0 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'	
	
"	^ '-arch i386 -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=0 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'"! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:38'!
compilerFlags
	"depends on config ..."
	^ self compilerFlagsRelease! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'Igor.Stasenko 12/22/2010 14:53'!
compilerFlagsDebug

	^ self commonCompilerFlags , ' -O0 -Wmissing-prototypes -Wmissing-braces -Wparentheses -Wunused-function -Wunused-label -Wunused-parameter -Wunused-variable -Wunused-value -Wsign-compare -DDEBUG -DDEBUGVM=1 -DEXTERNALPRIMSDEBUG=1 -gdwarf-2 '! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'Igor.Stasenko 12/27/2010 14:50'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ self commonCompilerFlags , ' -gdwarf-2 -O3 -funroll-loops -ftree-vectorize -msse3 -DDEBUGVM=0 -DNDEBUG=1 -Wunused-value -Wuninitialized -falign-functions=16 -fno-gcse -mtune=prescott -march=pentium-m -mfpmath=sse -finline-functions -Wall -DUSE_INLINE_MEMORY_ACCESSORS'! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:10'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/29/2010 15:19'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:12'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 17:01'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:16'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			'sqMacAudioDeviceList.c' 
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:17'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/22/2010 15:12'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogMacOSConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 12/27/2010 21:55'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ReentrantIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		"UnixOSProcessPlugin ?? "
		)! !

!CogMacOSConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 12/22/2010 15:47'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		QVMProfileMacSupportPlugin
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		)! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 22:45'!
executableType
	^ 'MACOSX_BUNDLE'! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'Igor.Stasenko 12/23/2010 20:17'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/25/2010 01:03'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'Igor.Stasenko 12/25/2010 01:07'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' to: '${topDir}/macbuild/resources/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 19:39'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 2/16/2011 10:50'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:30'!
interpreterClass
	^ CoInterpreter! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:47'!
platformName
	^ 'Mac OS'! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/23/2010 20:00'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:19'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:12'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:08'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForCogGeneration
! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'Igor.Stasenko 1/15/2011 17:10'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/23/2010 20:45'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

CogMacOSConfig subclass: #MTCogMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!MTCogMacOSConfig commentStamp: 'IgorStasenko 3/19/2011 21:33' prior: 0!
MTCogMacOSConfig generateWithSources!

!MTCogMacOSConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/19/2011 21:37'!
commonCompilerFlags

	"Common compiler flags"
	
	^ ' -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=1 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'	
	! !

!MTCogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/19/2011 21:32'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!MTCogMacOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/19/2011 21:32'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!MTCogMacOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/19/2011 21:32'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		"UnixOSProcessPlugin ?? "
	)! !

!MTCogMacOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!MTCogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/19/2011 21:30'!
interpreterClass
	^ CoInterpreterMT! !

CogMacOSConfig subclass: #StackInterpreterMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!StackInterpreterMacOSConfig commentStamp: 'IgorStasenko 3/18/2011 02:27' prior: 0!
StackInterpreterMacOSConfig generateWithSources.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).!

StackInterpreterMacOSConfig subclass: #StackInterpreterDebugMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!StackInterpreterDebugMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:50'!
compilerFlags

    ^  self compilerFlagsDebug! !

!StackInterpreterMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/30/2010 09:46'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackInterpreterMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/30/2010 10:16'!
executableName
	^ 'StackVM'! !

!StackInterpreterMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:06'!
interpreterClass
	^ StackInterpreter! !

!StackInterpreterMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:09'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

!MacOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 08:33'!
cMakeMacros 
	^'macro(add_framework appname fwname)
    find_library(FRAMEWORK_${fwname}
        NAMES ${fwname}
        PATHS ${CMAKE_OSX_SYSROOT}/System/Library
        PATH_SUFFIXES Frameworks
        NO_DEFAULT_PATH)
    if( ${FRAMEWORK_${fwname}} STREQUAL FRAMEWORK_${fwname}-NOTFOUND)
        message(ERROR ": Framework ${fwname} not found")
    else()
	  include_directories(SYSTEM /System/Library/Frameworks/${fwname}.framework/Headers)
	  target_link_libraries(${appname} ${FRAMEWORK_${fwname}})
    endif()
endmacro(add_framework)'  ! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:15'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	maker addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"

	super configureCroquetPlugin: maker.  
	maker addPlatformSources: #('sqMacCroquet.c').
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:23'!
configureFFIPlugin: maker
	super configureFFIPlugin: maker.
	maker addPlatformSources: #( "'sqMacIntel-Win32.c'"
		'x86-sysv-MacIntel.c'
		'x86-sysv-asm-MacIntel.S'
	)! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"
	
	super configureInternetConfigPlugin: maker.  
	maker addPlatformSources: #( 'sqMacInternetConfiguration.c')
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  
	maker addPlatformSources: #( 'sqMacMIDI.c')! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/15/2011 15:38'!
configureMpeg3Plugin: maker

	super configureMpeg3Plugin: maker.
	
	maker addPlatformSources: #(	
		'sqMacFileBits.c')
	! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 07:28'!
configureObjectiveCPlugin: maker
	maker doNotGenerate: true! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:15'!
configurePlugin: aPlugin with: generator

	generator isExternal ifTrue: [
		" set output directory for dynamic library to Resources subdir in .app bundle location "
		generator 
			set: 'CMAKE_LIBRARY_OUTPUT_DIRECTORY' 
			toString: '../',self executableName,'.app/Contents/Resources'.
		].
	^ super configurePlugin: aPlugin with: generator
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker addPlatformSources: #( 'sqMacSecurity.c' )! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

	super configureSerialPlugin: maker.  
	maker addPlatformSources: #( 'sqMacSerialPort.c' )

! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 14:22'!
configureSocketPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SocketPlugin'.
	maker 
		addSources: #('sqUnixSocket.c') 
		prefixed: '${platformsDir}/unix/plugins/SocketPlugin/'


! !

!MacOSConfig methodsFor: 'utils' stamp: 'EstebanLorenzano 1/3/2011 08:16'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!MacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:07'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

! !
